import { Observable } from 'tns-core-modules/data/observable';
export interface StompClientCallback {
    stompClientDidDisconnect(client: StompClientCommon): any;
    stompClientDidConnect(client: StompClientCommon): any;
    stompClientDidReceiveMessage(client: StompClientCommon, destination: string, jsonBody: string): any;
    serverDidSendReceipt(client: StompClientCommon, receiptId: string): any;
    serverDidSendError(client: StompClientCommon, description: string, message: string): any;
    serverDidSendPing(): any;
}
export declare class StompClientCommon extends Observable {
    currentUrl: string;
    delegate: StompClientCallback;
    constructor(callback?: StompClientCallback);
    openSocketWithURL(url: string): void;
    subscribe(destination: string): void;
    disconnect(): void;
    sendMessage(message: string, toDestination: String, withHeaders?: Map<String, String>, withReceipt?: string): void;
}
export declare class Utils {
}
