import { StompClientCallback, StompClientCommon } from './stomp-client.common';
export declare class StompClientLibDelegate {
}
export declare class StompClientLibDelegateImpl extends NSObject implements StompClientLibDelegate {
    static ObjCProtocols: (typeof StompClientLibDelegate)[];
    static new(): StompClientLibDelegateImpl;
    private owner;
    setOwner(owner: StompClientCommon): StompClientLibDelegateImpl;
    stompClientWithClientDidReceiveMessageWithJSONBodyWithHeaderWithDestination(client: any, jsonBody: any, header: any, destination: any): void;
    stompClientDidConnectWithClient(client: any): void;
    stompClientDidDisconnectWithClient(client: any): void;
    serverDidSendReceiptWithClientWithReceiptId(client: any, receiptId: string): void;
    serverDidSendErrorWithClientWithErrorMessageDetailedErrorMessage(client: any, errorMessage: string, detailedErrorMessage: string): void;
    serverDidSendPing(): void;
}
export declare class StompClient extends StompClientCommon {
    private socketClient;
    private iosDelegate;
    constructor(callback?: StompClientCallback);
    openSocketWithURL(url: string): void;
    subscribe(destination: string): void;
    disconnect(): void;
    sendMessage(message: string, toDestination: String, withHeaders?: Map<String, String>, withReceipt?: string): void;
}
