"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var stomp_client_common_1 = require("./stomp-client.common");
var StompClientLibDelegateImpl = (function (_super) {
    __extends(StompClientLibDelegateImpl, _super);
    function StompClientLibDelegateImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StompClientLibDelegateImpl.new = function () {
        return _super.new.call(this);
    };
    StompClientLibDelegateImpl.prototype.setOwner = function (owner) {
        this.owner = owner;
        return this;
    };
    StompClientLibDelegateImpl.prototype.stompClientWithClientDidReceiveMessageWithJSONBodyWithHeaderWithDestination = function (client, jsonBody, header, destination) {
        if (this.owner && this.owner.delegate) {
            this.owner.delegate.stompClientDidReceiveMessage(this.owner, destination, jsonBody);
        }
    };
    StompClientLibDelegateImpl.prototype.stompClientDidConnectWithClient = function (client) {
        if (this.owner && this.owner.delegate) {
            this.owner.delegate.stompClientDidConnect(this.owner);
        }
    };
    StompClientLibDelegateImpl.prototype.stompClientDidDisconnectWithClient = function (client) {
        if (this.owner && this.owner.delegate) {
            this.owner.delegate.stompClientDidDisconnect(this.owner);
        }
    };
    StompClientLibDelegateImpl.prototype.serverDidSendReceiptWithClientWithReceiptId = function (client, receiptId) {
        if (this.owner && this.owner.delegate) {
            this.owner.delegate.serverDidSendReceipt(this.owner, receiptId);
        }
    };
    StompClientLibDelegateImpl.prototype.serverDidSendErrorWithClientWithErrorMessageDetailedErrorMessage = function (client, errorMessage, detailedErrorMessage) {
        console.log('Error!! ' + errorMessage);
        if (this.owner && this.owner.delegate) {
            this.owner.delegate.serverDidSendError(this.owner, errorMessage, detailedErrorMessage);
        }
    };
    StompClientLibDelegateImpl.prototype.serverDidSendPing = function () {
        if (this.owner && this.owner.delegate) {
            this.owner.delegate.serverDidSendPing();
        }
    };
    StompClientLibDelegateImpl.ObjCProtocols = [StompClientLibDelegate];
    return StompClientLibDelegateImpl;
}(NSObject));
exports.StompClientLibDelegateImpl = StompClientLibDelegateImpl;
var StompClient = (function (_super) {
    __extends(StompClient, _super);
    function StompClient(callback) {
        if (callback === void 0) { callback = null; }
        var _this = _super.call(this, callback) || this;
        _this.socketClient = null;
        _this.iosDelegate = null;
        _this.iosDelegate = StompClientLibDelegateImpl.new().setOwner(_this);
        _this.socketClient = StompClientLib.new();
        console.log(_this.socketClient);
        return _this;
    }
    StompClient.prototype.openSocketWithURL = function (url) {
        this.currentUrl = url;
        this.socketClient.openSocketWithURLRequestWithRequestDelegate(NSURLRequest.requestWithURL(NSURL.URLWithString(url)), this.iosDelegate);
    };
    StompClient.prototype.subscribe = function (destination) {
        this.socketClient.subscribeWithDestination(destination);
    };
    StompClient.prototype.disconnect = function () {
        this.currentUrl = null;
        this.socketClient.disconnect();
    };
    StompClient.prototype.sendMessage = function (message, toDestination, withHeaders, withReceipt) {
        this.socketClient.sendMessageWithMessageToDestinationWithHeadersWithReceipt(message, toDestination, withHeaders, withReceipt);
    };
    return StompClient;
}(stomp_client_common_1.StompClientCommon));
exports.StompClient = StompClient;
//# sourceMappingURL=stomp-client.ios.js.map